[package]
name = "xand_ledger"
version = "0.62.2"
authors = ["Transparent Engineers <engineering@tpfs.io>"]
edition = "2021"
description = "The processing and validation logic library of transactions on a Xand blockchain"
license = "MIT OR Apache-2.0"

[features]
default = ['std']
test-helpers = ['zkplmt/test-helpers']
std = [
    'curve25519-dalek/std',
    'derive_builder',
    'rand/std',
    'serde-scale/std',
    'serde/std',
    'thiserror',
    'zkplmt/std'
]
alloc = ["serde/alloc"]


[[bench]]
name = "bench"
harness = false
required-features = ["test-helpers"]

[dependencies]
curve25519-dalek = { version = "2.0.0", features = ["u64_backend", "alloc", "serde"], default-features = false }
derive_more = { version = "0.99.17", default-features = false, features = [
    "add",
    "display",
    "from",
    "into",
    "constructor",
] }
derive_builder = { version = "0.9", optional = true }
enum-iterator = "0.7.0"
hex = { version = "0.4.3", default-features = false, features = ["alloc", "serde"] }
lazy_static = { version = "1.4", features = ["spin_no_std"] }
rand = { version = "0.7", features = ["getrandom"], default-features = false }
sha2 = { version = "0.8.0", default-features = false }
bs58 =  { version = "0.3.1", features = ["alloc"], default-features = false }
serde = { version = "1.0", features = ["derive"], default-features = false }
serde-scale = { version = "0.2", features = ["alloc"], default-features = false }
thiserror = { version = "1.0.26", optional = true }
zkplmt = { version = "0.4.5", default-features = false }

[dev-dependencies]
assert_matches = "1.5.0"
criterion = { version = "0.3", features = ["html_reports"] }
insta = "1.8.0"
mockall = "0.8"
proptest = "0.10"
serde_test = "1.0.132"
zkplmt = { version = "0.4.5", default-features = false, features = ["test-helpers"] }
zkplmt-test-helpers = { version = "0.4.5" }

[build-dependencies]
zkplmt = { version = "0.4.5", default-features = false }
serde-scale = { version = "0.2", default-features = false, features = ["alloc"] }
